#line 18 "pdl.h.PL"

/*
 * THIS FILE IS GENERATED FROM pdl.h.PL! Do NOT edit!
 */

#ifndef __PDL_H
#define __PDL_H

#include <complex.h>

#define PDL_DEBUGGING 1

#ifdef PDL_DEBUGGING
extern int pdl_debugging;
#define PDLDEBUG_f(a)           if(pdl_debugging) a
#else
#define PDLDEBUG_f(a)
#endif

#define ANYVAL_ISBAD(inany,pdl,badval) \
  (ANYVAL_ISNAN(badval) ? ANYVAL_ISNAN(inany) : ANYVAL_EQ_ANYVAL(inany, badval))

typedef struct pdl pdl;


/*****************************************************************************/
/*** This section of .h file generated automatically by ***/
/*** PDL::Types::datatypes_header() - don't edit manually ***/

/* Data types/sizes [must be in order of complexity] */

typedef enum { PDL_INVALID=-1, PDL_B, PDL_S, PDL_US, PDL_L, PDL_IND, PDL_LL, PDL_F, PDL_D, PDL_CF, PDL_CD } pdl_datatypes;

/* Define the pdl data types */

typedef unsigned char PDL_Byte;
typedef short PDL_Short;
typedef unsigned short PDL_Ushort;
typedef int PDL_Long;
typedef long long PDL_Indx;
typedef long long PDL_LongLong;
typedef float PDL_Float;
typedef double PDL_Double;
typedef complex float PDL_CFloat;
typedef complex double PDL_CDouble;
typedef struct {
  pdl_datatypes type;
  union {
  PDL_Byte B;
  PDL_Short S;
  PDL_Ushort U;
  PDL_Long L;
  PDL_Indx N;
  PDL_LongLong Q;
  PDL_Float F;
  PDL_Double D;
  PDL_CFloat G;
  PDL_CDouble C;
  } value;
} PDL_Anyval;
#define IND_FLAG "lld"


/*****************************************************************************/


#define PDL_U PDL_US
#define PDL_N PDL_IND
#define PDL_Q PDL_LL
#define PDL_G PDL_CF
#define PDL_C PDL_CD



#include "pdlthread.h"

/* Auto-PThreading (i.e. multi-threading) settings for PDL functions */
/*  Target number of pthreads: Actual will be this number or less.
    A 0 here means no pthreading */
extern int pdl_autopthread_targ;

/*  Actual number of pthreads: This is the number of pthreads created for the last
    operation where pthreading was used
    A 0 here means no pthreading */
extern int pdl_autopthread_actual;
/* Minimum size of the target PDL involved in pdl function to attempt pthreading (in MBytes )
    For small PDLs, it probably isn't worth starting multiple pthreads, so this variable
    is used to define that threshold (in M-elements, or 2^20 elements ) */
extern int pdl_autopthread_size;
extern PDL_Indx pdl_autopthread_dim;



#define ANYVAL_EQ_ANYVAL(x,y) (_anyval_eq_anyval(x,y))

#line 69 "pdl.h.PL"
static inline int _anyval_eq_anyval(PDL_Anyval x, PDL_Anyval y) {
  switch (x.type) {
    case PDL_B:
      switch (y.type) {
        case PDL_B: return (x.value.B == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.B == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.B == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.B == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.B == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.B == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.B == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.B == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.B == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.B == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_S:
      switch (y.type) {
        case PDL_B: return (x.value.S == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.S == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.S == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.S == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.S == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.S == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.S == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.S == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.S == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.S == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_US:
      switch (y.type) {
        case PDL_B: return (x.value.U == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.U == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.U == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.U == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.U == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.U == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.U == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.U == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.U == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.U == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_L:
      switch (y.type) {
        case PDL_B: return (x.value.L == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.L == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.L == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.L == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.L == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.L == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.L == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.L == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.L == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.L == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_IND:
      switch (y.type) {
        case PDL_B: return (x.value.N == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.N == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.N == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.N == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.N == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.N == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.N == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.N == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.N == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.N == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_LL:
      switch (y.type) {
        case PDL_B: return (x.value.Q == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.Q == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.Q == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.Q == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.Q == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.Q == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.Q == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.Q == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.Q == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.Q == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_F:
      switch (y.type) {
        case PDL_B: return (x.value.F == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.F == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.F == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.F == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.F == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.F == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.F == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.F == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.F == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.F == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_D:
      switch (y.type) {
        case PDL_B: return (x.value.D == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.D == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.D == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.D == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.D == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.D == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.D == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.D == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.D == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.D == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_CF:
      switch (y.type) {
        case PDL_B: return (x.value.G == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.G == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.G == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.G == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.G == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.G == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.G == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.G == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.G == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.G == y.value.C) ? 1 : 0;
        default: return 0;
      }
    case PDL_CD:
      switch (y.type) {
        case PDL_B: return (x.value.C == y.value.B) ? 1 : 0;
        case PDL_S: return (x.value.C == y.value.S) ? 1 : 0;
        case PDL_US: return (x.value.C == y.value.U) ? 1 : 0;
        case PDL_L: return (x.value.C == y.value.L) ? 1 : 0;
        case PDL_IND: return (x.value.C == y.value.N) ? 1 : 0;
        case PDL_LL: return (x.value.C == y.value.Q) ? 1 : 0;
        case PDL_F: return (x.value.C == y.value.F) ? 1 : 0;
        case PDL_D: return (x.value.C == y.value.D) ? 1 : 0;
        case PDL_CF: return (x.value.C == y.value.G) ? 1 : 0;
        case PDL_CD: return (x.value.C == y.value.C) ? 1 : 0;
        default: return 0;
      }
    default:
      return 0;
  }
}
#line 88 "pdl.h.PL"
#define ANYVAL_FROM_CTYPE(outany,avtype,inval) do { switch (avtype) { \
case PDL_B: outany.type = avtype; outany.value.B = (PDL_Byte)(inval); break; \
case PDL_S: outany.type = avtype; outany.value.S = (PDL_Short)(inval); break; \
case PDL_US: outany.type = avtype; outany.value.U = (PDL_Ushort)(inval); break; \
case PDL_L: outany.type = avtype; outany.value.L = (PDL_Long)(inval); break; \
case PDL_IND: outany.type = avtype; outany.value.N = (PDL_Indx)(inval); break; \
case PDL_LL: outany.type = avtype; outany.value.Q = (PDL_LongLong)(inval); break; \
case PDL_F: outany.type = avtype; outany.value.F = (PDL_Float)(inval); break; \
case PDL_D: outany.type = avtype; outany.value.D = (PDL_Double)(inval); break; \
case PDL_CF: outany.type = avtype; outany.value.G = (PDL_CFloat)(inval); break; \
case PDL_CD: outany.type = avtype; outany.value.C = (PDL_CDouble)(inval); break; \
   default:      outany.type = -1;     outany.value.B = 0; \
  } \
 } while (0)
#line 100 "pdl.h.PL"
#define ANYVAL_TO_CTYPE(outval,ctype,inany) do { switch (inany.type) { \
case PDL_B: outval = (ctype)(inany.value.B); break; \
case PDL_S: outval = (ctype)(inany.value.S); break; \
case PDL_US: outval = (ctype)(inany.value.U); break; \
case PDL_L: outval = (ctype)(inany.value.L); break; \
case PDL_IND: outval = (ctype)(inany.value.N); break; \
case PDL_LL: outval = (ctype)(inany.value.Q); break; \
case PDL_F: outval = (ctype)(inany.value.F); break; \
case PDL_D: outval = (ctype)(inany.value.D); break; \
case PDL_CF: outval = (ctype)(inany.value.G); break; \
case PDL_CD: outval = (ctype)(inany.value.C); break; \
default:      outval = 0; \
            } \
        } while (0)
#define ANYVAL_FROM_CTYPE_OFFSET(outany,avtype,indata,ioff) do { switch (avtype) { \
case PDL_B: outany.type = avtype; outany.value.B = (PDL_Byte)((PDL_Byte *)indata)[ioff]; break; \
case PDL_S: outany.type = avtype; outany.value.S = (PDL_Short)((PDL_Short *)indata)[ioff]; break; \
case PDL_US: outany.type = avtype; outany.value.U = (PDL_Ushort)((PDL_Ushort *)indata)[ioff]; break; \
case PDL_L: outany.type = avtype; outany.value.L = (PDL_Long)((PDL_Long *)indata)[ioff]; break; \
case PDL_IND: outany.type = avtype; outany.value.N = (PDL_Indx)((PDL_Indx *)indata)[ioff]; break; \
case PDL_LL: outany.type = avtype; outany.value.Q = (PDL_LongLong)((PDL_LongLong *)indata)[ioff]; break; \
case PDL_F: outany.type = avtype; outany.value.F = (PDL_Float)((PDL_Float *)indata)[ioff]; break; \
case PDL_D: outany.type = avtype; outany.value.D = (PDL_Double)((PDL_Double *)indata)[ioff]; break; \
case PDL_CF: outany.type = avtype; outany.value.G = (PDL_CFloat)((PDL_CFloat *)indata)[ioff]; break; \
case PDL_CD: outany.type = avtype; outany.value.C = (PDL_CDouble)((PDL_CDouble *)indata)[ioff]; break; \
   default:      outany.type = -1;     outany.value.B = 0; \
  } \
 } while (0)
/* input vars have to be called exactly these as not expanded */
#define ANYVAL_TO_CTYPE_OFFSET_X(datatype, generic, generic_ppsym, shortctype, defbval) \
    ANYVAL_TO_CTYPE(((generic *)x)[ioff], generic, value);
#define ANYVAL_TO_CTYPE_OFFSET(x,ioff,datatype,value) \
    PDL_GENERICSWITCH(datatype, ANYVAL_TO_CTYPE_OFFSET_X)
#define ANYVAL_ISNAN(x) (\
  (x).type < PDL_F ? 0 : \
  (x).type == PDL_F ? isnan((x).value.F) : \
  (x).type == PDL_D ? isnan((x).value.D) : \
  (x).type == PDL_CF ? (isnan(crealf((x).value.G)) || isnan(cimagf((x).value.G))) : \
  (x).type == PDL_CD ? (isnan(creal((x).value.C)) || isnan(cimag((x).value.C))) : \
  (croak("ANYVAL_ISNAN should not get here, had type %d", (x).type), 1) \
)
#define PDL_ISNAN_B(x) (FALSE)
#define PDL_ISFINITE_B(x) (TRUE)
#define PDL_ISNAN_S(x) (FALSE)
#define PDL_ISFINITE_S(x) (TRUE)
#define PDL_ISNAN_U(x) (FALSE)
#define PDL_ISFINITE_U(x) (TRUE)
#define PDL_ISNAN_L(x) (FALSE)
#define PDL_ISFINITE_L(x) (TRUE)
#define PDL_ISNAN_N(x) (FALSE)
#define PDL_ISFINITE_N(x) (TRUE)
#define PDL_ISNAN_Q(x) (FALSE)
#define PDL_ISFINITE_Q(x) (TRUE)
#define PDL_ISNAN_F(x) (isnan(x))
#define PDL_ISFINITE_F(x) (isfinite(x))
#define PDL_ISNAN_D(x) (isnan(x))
#define PDL_ISFINITE_D(x) (isfinite(x))
#define PDL_ISNAN_G(x) ((isnan(crealf(x)) || isnan(cimagf(x))))
#define PDL_ISFINITE_G(x) ((isfinite(crealf(x)) && isfinite(cimagf(x))))
#define PDL_ISNAN_C(x) ((isnan(creal(x)) || isnan(cimag(x))))
#define PDL_ISFINITE_C(x) ((isfinite(creal(x)) && isfinite(cimag(x))))
#define PDL_GENERICLIST(X) \
 X(PDL_B,PDL_Byte,B,Byte,UCHAR_MAX)\
 X(PDL_S,PDL_Short,S,Short,SHRT_MIN)\
 X(PDL_US,PDL_Ushort,U,Ushort,USHRT_MAX)\
 X(PDL_L,PDL_Long,L,Long,INT_MIN)\
 X(PDL_IND,PDL_Indx,N,Indx,LONG_MIN)\
 X(PDL_LL,PDL_LongLong,Q,LongLong,LONG_MIN)\
 X(PDL_F,PDL_Float,F,Float,-FLT_MAX)\
 X(PDL_D,PDL_Double,D,Double,-DBL_MAX)\
 X(PDL_CF,PDL_CFloat,G,CFloat,(-FLT_MAX - I*FLT_MAX))\
 X(PDL_CD,PDL_CDouble,C,CDouble,(-DBL_MAX - I*DBL_MAX))\


#define PDL_GENERICLIST2(X, X2) \
 X(X2, PDL_B,PDL_Byte,B,Byte,UCHAR_MAX)\
 X(X2, PDL_S,PDL_Short,S,Short,SHRT_MIN)\
 X(X2, PDL_US,PDL_Ushort,U,Ushort,USHRT_MAX)\
 X(X2, PDL_L,PDL_Long,L,Long,INT_MIN)\
 X(X2, PDL_IND,PDL_Indx,N,Indx,LONG_MIN)\
 X(X2, PDL_LL,PDL_LongLong,Q,LongLong,LONG_MIN)\
 X(X2, PDL_F,PDL_Float,F,Float,-FLT_MAX)\
 X(X2, PDL_D,PDL_Double,D,Double,-DBL_MAX)\
 X(X2, PDL_CF,PDL_CFloat,G,CFloat,(-FLT_MAX - I*FLT_MAX))\
 X(X2, PDL_CD,PDL_CDouble,C,CDouble,(-DBL_MAX - I*DBL_MAX))\


#define PDL_GENERICLIST2_(X, X2) \
 X(X2, PDL_B,PDL_Byte,B,Byte,UCHAR_MAX)\
 X(X2, PDL_S,PDL_Short,S,Short,SHRT_MIN)\
 X(X2, PDL_US,PDL_Ushort,U,Ushort,USHRT_MAX)\
 X(X2, PDL_L,PDL_Long,L,Long,INT_MIN)\
 X(X2, PDL_IND,PDL_Indx,N,Indx,LONG_MIN)\
 X(X2, PDL_LL,PDL_LongLong,Q,LongLong,LONG_MIN)\
 X(X2, PDL_F,PDL_Float,F,Float,-FLT_MAX)\
 X(X2, PDL_D,PDL_Double,D,Double,-DBL_MAX)\
 X(X2, PDL_CF,PDL_CFloat,G,CFloat,(-FLT_MAX - I*FLT_MAX))\
 X(X2, PDL_CD,PDL_CDouble,C,CDouble,(-DBL_MAX - I*DBL_MAX))\


#define PDL_GENERICLIST_REAL(X) \
 X(PDL_B,PDL_Byte,B,Byte,UCHAR_MAX)\
 X(PDL_S,PDL_Short,S,Short,SHRT_MIN)\
 X(PDL_US,PDL_Ushort,U,Ushort,USHRT_MAX)\
 X(PDL_L,PDL_Long,L,Long,INT_MIN)\
 X(PDL_IND,PDL_Indx,N,Indx,LONG_MIN)\
 X(PDL_LL,PDL_LongLong,Q,LongLong,LONG_MIN)\
 X(PDL_F,PDL_Float,F,Float,-FLT_MAX)\
 X(PDL_D,PDL_Double,D,Double,-DBL_MAX)\


typedef struct badvals {
#define X(symbol, ctype, ppsym, shortctype, defbval) ctype shortctype;
PDL_GENERICLIST(X)
#undef X
} badvals;

#define PDL_GENERICSWITCH_CASE(X, symbol, ...) \
  case symbol: { X(symbol, __VA_ARGS__) } break;
#define PDL_GENERICSWITCH(typevar, X2) \
  switch (typevar) { \
    PDL_GENERICLIST2(PDL_GENERICSWITCH_CASE, X2) \
    default: croak("Not a known data type code=%d", typevar); \
  }
/* extra as first one gets painted blue */
#define PDL_GENERICSWITCH_CASE2(X, symbol, ...) \
  case symbol: { X(symbol, __VA_ARGS__) } break;
/* for use in inner loops avoiding extreme lambda-calculus stuff */
#define PDL_GENERICSWITCH2(typevar, X2) \
  switch (typevar) { \
    PDL_GENERICLIST2_(PDL_GENERICSWITCH_CASE2, X2) \
    default: croak("Not a known data type code=%d", typevar); \
  }

/*
 * Define the pdl C data structure which maps onto the original PDL
 * perl data structure.
 *
 * Note: pdl.sv is defined as a void pointer to avoid having to
 * include perl.h in C code which just needs the pdl data.
 *
 * We start with the meanings of the pdl.flags bitmapped flagset,
 * continue with a prerequisite "trans" structure that represents
 * transformations between linked PDLs, and finish withthe PD
 * structure itself.
*/

#define PDL_NDIMS      6 /* Number of dims[] to preallocate */
#define PDL_NCHILDREN  8 /* Number of children ptrs to preallocate */
#define PDL_NTHREADIDS 4 /* Number of different threadids/pdl to preallocate */

/* Constants for pdl.state - not all combinations make sense */

  /* data allocated for this pdl.  this implies that the data               */
  /* is up to date if !PDL_PARENTCHANGED                                    */
#define  PDL_ALLOCATED           0x0001
  /* Parent data has been altered without changing this pdl                 */
#define  PDL_PARENTDATACHANGED   0x0002
  /* Parent dims or incs has been altered without changing this pdl.        */
#define  PDL_PARENTDIMSCHANGED   0x0004
  /* Physical data representation of the parent has changed (e.g.           */
  /* physical transposition), so incs etc. need to be recalculated.         */
#define  PDL_PARENTREPRCHANGED   0x0008
#define  PDL_ANYCHANGED          (PDL_PARENTDATACHANGED|PDL_PARENTDIMSCHANGED|PDL_PARENTREPRCHANGED)
  /* Dataflow tracking flags -- F/B for forward/back.  These get set        */
  /* by transformations when they are set up.                               */
#define  PDL_DATAFLOW_F          0x0010
#define  PDL_DATAFLOW_B          0x0020
#define  PDL_DATAFLOW_ANY        (PDL_DATAFLOW_F|PDL_DATAFLOW_B)
  /* Was this PDL null originally?                                          */
#define  PDL_NOMYDIMS            0x0040
  /* Dims should be received via trans.                                     */
#define  PDL_MYDIMS_TRANS        0x0080
  /* OK to attach a vaffine transformation (i.e. a slice)                   */
#define  PDL_OPT_VAFFTRANSOK     0x0100
#define  PDL_OPT_ANY_OK          (PDL_OPT_VAFFTRANSOK)
  /* This is the hdrcpy flag                                                */
#define  PDL_HDRCPY              0x0200
  /* This is a badval flag for this PDL (hmmm -- there is also a flag       */
  /* in the struct itself -- must be clearer about what this is for. --CED) */
#define  PDL_BADVAL              0x0400
  /* Debugging flag                                                         */
#define  PDL_TRACEDEBUG          0x0800
  /* inplace flag                                                           */
#define  PDL_INPLACE             0x1000
  /* Flag indicating destruction in progress                                */
#define         PDL_DESTROYING          0x2000
  /* If this flag is set, you must not alter the data pointer nor           */
  /* free this ndarray nor use datasv (which should be null).                */
  /* This means e.g. that the ndarray is mmapped from a file                 */
#define         PDL_DONTTOUCHDATA       0x4000
  /* whether the given pdl is getting its dims from the given trans */
#define PDL_DIMS_FROM_TRANS(wtrans,pdl) (((pdl)->state & PDL_MYDIMS_TRANS) \
                && (pdl)->trans_parent == (pdl_trans *)(wtrans))

#define PDL_LIST_FLAGS_PDLSTATE(X) \
 X(PDL_ALLOCATED) \
 X(PDL_PARENTDATACHANGED) \
 X(PDL_PARENTDIMSCHANGED) \
 X(PDL_PARENTREPRCHANGED) \
 X(PDL_DATAFLOW_F) \
 X(PDL_DATAFLOW_B) \
 X(PDL_NOMYDIMS) \
 X(PDL_MYDIMS_TRANS) \
 X(PDL_OPT_VAFFTRANSOK) \
 X(PDL_HDRCPY) \
 X(PDL_BADVAL) \
 X(PDL_TRACEDEBUG) \
 X(PDL_INPLACE) \
 X(PDL_DESTROYING) \
 X(PDL_DONTTOUCHDATA)

/**************************************************
 *
 * Transformation structure
 *
 * The structure is general enough to deal with functional transforms
 * (which were originally intended) but only slices and retype transforms
 * were implemented.
 *
 */

/* Transformation flags */
#define         PDL_TRANS_DO_THREAD        0x0001
#define         PDL_TRANS_BADPROCESS       0x0002
#define         PDL_TRANS_BADIGNORE        0x0004
#define         PDL_TRANS_NO_PARALLEL      0x0008

#define PDL_LIST_FLAGS_PDLVTABLE(X) \
  X(PDL_TRANS_DO_THREAD) \
  X(PDL_TRANS_BADPROCESS) \
  X(PDL_TRANS_BADIGNORE) \
  X(PDL_TRANS_NO_PARALLEL)

/* Transpdl flags */
#define         PDL_TPDL_VAFFINE_OK     0x01

typedef struct pdl_trans pdl_trans;

typedef struct pdl_transvtable {
        int flags;
        int iflags; /* flags that are starting point for pdl_trans.flags */
        pdl_datatypes *gentypes; /* ordered list of types handled, ending -1 */
        PDL_Indx nparents;
        PDL_Indx npdls;
        char *per_pdl_flags;
        PDL_Indx *par_realdims; /* quantity of dimensions each par has */
        char **par_names;
        short *par_flags;
        pdl_datatypes *par_types;
        PDL_Indx *par_realdim_ind_start; /* each par, where do its inds start in array above */
        PDL_Indx *par_realdim_ind_ids; /* each realdim, which ind is source */
        PDL_Indx nind_ids;
        PDL_Indx ninds;
        char **ind_names; /* sorted names of "indices", eg for a(m), the "m" */
        void (*redodims)(pdl_trans *tr);      /* Only dims and internal trans (makes phys) */
        void (*readdata)(pdl_trans *tr);      /* Only data, to "data" ptr  */
        void (*writebackdata)(pdl_trans *tr); /* "data" ptr to parent or granny */
        void (*freetrans)(pdl_trans *tr);     /* Free both the contents and it of
                                                 the trans_parent member */
        int structsize;
        char *name;                           /* For debuggers, mostly */
} pdl_transvtable;

/* offset into either par_realdim_ind_ids or inc_sizes */
#define PDL_INC_ID(vtable, i, j) \
  ((vtable)->par_realdim_ind_start[i] + j)
/* which ind_id (named dim) for the i-th pdl (aka param) in a vtable, the j-th dim on that param */
#define PDL_IND_ID(vtable, i, j) \
  ((vtable)->par_realdim_ind_ids[PDL_INC_ID(vtable, i, j)])

#define PDL_PARAM_ISREAL             0x0001
#define PDL_PARAM_ISCOMPLEX          0x0002
#define PDL_PARAM_ISTYPED            0x0004
#define PDL_PARAM_ISTPLUS            0x0008
#define PDL_PARAM_ISCREAT            0x0010
#define PDL_PARAM_ISCREATEALWAYS     0x0020
#define PDL_PARAM_ISOUT              0x0040
#define PDL_PARAM_ISTEMP             0x0080
#define PDL_PARAM_ISWRITE            0x0100
#define PDL_PARAM_ISPHYS             0x0200
#define PDL_PARAM_ISIGNORE           0x0400

#define PDL_LIST_FLAGS_PARAMS(X) \
 X(PDL_PARAM_ISREAL) \
 X(PDL_PARAM_ISCOMPLEX) \
 X(PDL_PARAM_ISTYPED) \
 X(PDL_PARAM_ISTPLUS) \
 X(PDL_PARAM_ISCREAT) \
 X(PDL_PARAM_ISCREATEALWAYS) \
 X(PDL_PARAM_ISOUT) \
 X(PDL_PARAM_ISTEMP) \
 X(PDL_PARAM_ISWRITE) \
 X(PDL_PARAM_ISPHYS) \
 X(PDL_PARAM_ISIGNORE)

/* All trans must start with this */

/* Trans flags */

        /* Reversible transform -- flag indicates data can flow both ways.  */
        /* This is critical in routines that both input from and output to  */
        /* a non-single-valued pdl: updating must occur.  (Note that the    */
        /* transform is not necessarily mathematically reversible)          */
#define  PDL_ITRANS_TWOWAY        0x0001
        /* Whether, if a child is changed, this trans should be destroyed or not */
        /* (flow if set; sever if clear) */
#define  PDL_ITRANS_DO_DATAFLOW_F     0x0002
#define  PDL_ITRANS_DO_DATAFLOW_B     0x0004
#define  PDL_ITRANS_DO_DATAFLOW_ANY   (PDL_ITRANS_DO_DATAFLOW_F|PDL_ITRANS_DO_DATAFLOW_B)

#define  PDL_ITRANS_ISAFFINE          0x1000
#define  PDL_ITRANS_VAFFINEVALID      0x2000
#define  PDL_ITRANS_NONMUTUAL         0x4000  /* flag for destruction */

#define PDL_LIST_FLAGS_PDLTRANS(X) \
 X(PDL_ITRANS_TWOWAY) \
 X(PDL_ITRANS_DO_DATAFLOW_F) \
 X(PDL_ITRANS_DO_DATAFLOW_B) \
 X(PDL_ITRANS_ISAFFINE) \
 X(PDL_ITRANS_VAFFINEVALID) \
 X(PDL_ITRANS_NONMUTUAL)

#define PDL_MAXSPACE 256 /* maximal number of prefix spaces in dump routines */
#define PDL_MAXLIN 60

// These define struct pdl_trans and all derived structures. There are many
// structures that defined in other parts of the code that can be referenced
// like a pdl_trans* because all of these structures have the same pdl_trans
// initial piece. These structures can contain multiple pdl* elements in them.
// Thus pdl_trans itself ends with a flexible pdl*[] array, which can be used to
// reference any number of pdl objects. As a result pdl_trans itself can NOT be
// instantiated

#define PDL_TRANS_START_COMMON                                          \
  unsigned int magicno;                                                 \
  short flags;                                                          \
  pdl_transvtable *vtable;                                              \
  int bvalflag;                                                         \
  int has_badvalue;                                                     \
  PDL_Anyval badvalue;                                                  \
  pdl_thread pdlthread;                                                 \
  PDL_Indx *ind_sizes;                                                  \
  PDL_Indx *inc_sizes;                                                  \
  char dims_redone;                                                     \
  PDL_Indx *incs; PDL_Indx offs; /* only used for affine */             \
  void *params;                                                         \
  int __datatype

#define PDL_TRANS_START(np) \
  PDL_TRANS_START_COMMON; \
  /* The pdls involved in the transformation */ \
  pdl *pdls[np]

#define PDL_TRANS_START_FLEXIBLE() \
  PDL_TRANS_START_COMMON; \
  /* The pdls involved in the transformation */ \
  pdl *pdls[]

#define PDL_CHKMAGIC_GENERAL(it,this_magic,type) if((it)->magicno != this_magic) croak("INVALID " #type "MAGIC NO 0x%p %d%s\n",it,(int)((it)->magicno), ((it)->magicno) == PDL_CLEARED_MAGICNO ? " (cleared)" : ""); else (void)0

#define PDL_TR_MAGICNO      0x91827364
#define PDL_TR_SETMAGIC(it) it->magicno = PDL_TR_MAGICNO
#define PDL_TR_CLRMAGIC(it) it->magicno = PDL_CLEARED_MAGICNO
#define PDL_TR_CHKMAGIC(it) PDL_CHKMAGIC_GENERAL(it, PDL_TR_MAGICNO, "TRANS ")

// This is a generic parent of all the trans structures. It is a flexible array
// (can store an arbitrary number of pdl objects). Thus this can NOT be
// instantiated, only "child" structures can
struct pdl_trans {
  PDL_TRANS_START_FLEXIBLE();
} ;

typedef struct pdl_vaffine {
	PDL_TRANS_START(2);
	PDL_Indx ndims;
	PDL_Indx def_incs[PDL_NDIMS];
	pdl *from;
} pdl_vaffine;

#define PDL_VAFFOK(pdl) (pdl->state & PDL_OPT_VAFFTRANSOK)
#define PDL_REPRINC(pdl,which) (PDL_VAFFOK(pdl) ? \
                pdl->vafftrans->incs[which] : pdl->dimincs[which])

#define PDL_REPROFFS(pdl) (PDL_VAFFOK(pdl) ? pdl->vafftrans->offs : 0)

#define PDL_REPRP(pdl) (PDL_VAFFOK(pdl) ? pdl->vafftrans->from->data : pdl->data)

#define PDL_REPRP_TRANS(pdl,flag) ((PDL_VAFFOK(pdl) && \
      (flag & PDL_TPDL_VAFFINE_OK)) ? pdl->vafftrans->from->data : pdl->data)

#define VAFFINE_FLAG_OK(flags,i) ((flags == NULL) ? 1 : (flags[i] & \
                                  PDL_TPDL_VAFFINE_OK))

typedef struct pdl_children {
        pdl_trans *trans_parent[PDL_NCHILDREN];
        struct pdl_children *next;
} pdl_children;

struct pdl_magic;

/****************************************
 * PDL structure
 * Should be kept under 250 bytes if at all possible, for
 * easier segmentation...
 * See current size (360 bytes at time of writing) with:
      perl -Mblib -MInline=with,PDL \
        -MInline=C,'size_t f() { return sizeof(struct pdl); }' -e 'die f()'
 *
 * The 'sv', 'datasv', and 'hdrsv' fields are all void * to avoid having to
 * load perl.h for C codes that only use PDLs and not the Perl API.
 *
 * Similarly, the 'magic' field is void * to avoid having to typedef pdl_magic
 * here -- it is declared in "pdl_magic.h".
 */

#define PDL_MAGICNO 0x24645399
#define PDL_CLEARED_MAGICNO 0x99876134 /* value once "cleared" */
#define PDL_CHKMAGIC(it) PDL_CHKMAGIC_GENERAL(it,PDL_MAGICNO,"")

struct pdl {
   unsigned long magicno; /* Always stores PDL_MAGICNO as a sanity check */
     /* This is first so most pointer accesses to wrong type are caught */
   int state;        /* What's in this pdl */

   pdl_trans *trans_parent; /* Opaque pointer to internals of transformation from
                        parent */

   pdl_vaffine *vafftrans; /* pointer to vaffine transformation
                              a vafftrans is an optimization that is possible
                              for some types of trans (slice etc)
                              - unused for non-affine transformations
                            */

   void*    sv;      /* (optional) pointer back to original sv.
                          ALWAYS check for non-null before use.
                          We cannot inc refcnt on this one or we'd
                          never get destroyed */
   void *datasv;        /* Pointer to SV containing data. We own one inc of refcnt */
   void *data;            /* Pointer to actual data (in SV), or NULL if we have no data      */
   /* bad value stored as double, since get_badvalue returns a double */
   PDL_Anyval badvalue; /* BAD value is stored as a PDL_Anyval for portability */
   int has_badvalue;     /* flag is required by pdlapi.c (compare to PDL_BADVAL above -- why two? --CED) */
   PDL_Indx nvals; /* Actual size of data (not quite nelem in case of dummy) */
   pdl_datatypes datatype; /* One of the usual suspects (PDL_L, PDL_D, etc.) */
   PDL_Indx   *dims;      /* Array of data dimensions - could point below or to an allocated array */
   PDL_Indx   *dimincs;   /* Array of data default increments, aka strides through memory for each dim (0 for dummies) */
   PDL_Indx    ndims;     /* Number of data dimensions in dims and dimincs */

   PDL_Indx *threadids;  /* Starting index of the thread index set n */
   PDL_Indx nthreadids;

   pdl_children children;

   PDL_Indx   def_dims[PDL_NDIMS];   /* Preallocated space for efficiency */
   PDL_Indx   def_dimincs[PDL_NDIMS];   /* Preallocated space for efficiency */
   PDL_Indx   def_threadids[PDL_NTHREADIDS];

   struct pdl_magic *magic;

   void *hdrsv; /* "header", settable from Perl */
};

typedef struct pdl_slice_args {
  PDL_Indx start; /* maps to start index of slice range (inclusive) */
  PDL_Indx end; /* maps to end index of slice range (inclusive) */
  PDL_Indx inc; /* maps to increment of slice range */
  char dummy, squish; /* boolean */
  struct pdl_slice_args *next; /* NULL is last */
} pdl_slice_args;

/*************
 * Some macros for looping over the children of a given PDL
 */
#define PDL_DECL_CHILDLOOP(p) \
                int p##__i; pdl_children *p##__c;
#define PDL_START_CHILDLOOP(p) \
                p##__c = &p->children; \
                do { \
                        for(p##__i=0; p##__i<PDL_NCHILDREN; p##__i++) { \
                                if(p##__c->trans_parent[p##__i]) {
#define PDL_CHILDLOOP_THISCHILD(p) p##__c->trans_parent[p##__i]
#define PDL_END_CHILDLOOP(p) \
                                } \
                        } \
                        if(!p##__c) break; \
                        if(!p##__c->next) break; \
                        p##__c=p##__c->next; \
                } while(1);


#define PDLMAX(a,b) ((a) > (b) ? (a) : (b))
#define PDLMIN(a,b) ((a) < (b) ? (a) : (b))

/***************
 * Some macros to guard against dataflow infinite recursion.
 */
#define DECL_RECURSE_GUARD static int __nrec=0;
#define START_RECURSE_GUARD __nrec++; if(__nrec > 1000) {__nrec=0; die("PDL:Internal Error: data structure recursion limit exceeded (max 1000 levels)\n\tThis could mean that you have found an infinite-recursion error in PDL, or\n\tthat you are building data structures with very long dataflow dependency\n\tchains.  You may want to try using sever() to break the dependency.\n");}
#define ABORT_RECURSE_GUARD __nrec=0;
#define END_RECURSE_GUARD __nrec--;

#define PDL_ENSURE_ALLOCATED(it) ( (void)((it->state & PDL_ALLOCATED) || ((pdl_allocdata(it)),1)) )
#define PDL_ENSURE_VAFFTRANS(it) \
  ( ((!it->vafftrans) || (it->vafftrans->ndims < it->ndims)) && \
    (pdl_vafftrans_alloc(it),1) )

/* for use with PDL_GENERICLIST_REAL */
#define PDL_QSORT(symbol, ctype, ppsym, shortctype, defbval) \
  static inline void qsort_ ## ppsym(ctype* xx, PDL_Indx a, PDL_Indx b) { \
     PDL_Indx i,j; \
     ctype t, median; \
     i = a; j = b; \
     median = xx[(i+j) / 2]; \
     do { \
        while (xx[i] < median) \
           i++; \
        while (median < xx[j]) \
           j--; \
        if (i <= j) { \
           t = xx[i]; xx[i] = xx[j]; xx[j] = t; \
           i++; j--; \
        } \
     } while (i <= j); \
     if (a < j) \
        qsort_ ## ppsym(xx,a,j); \
     if (i < b) \
        qsort_ ## ppsym(xx,i,b); \
  }

/* __PDL_H */
#endif

